// Copyright: Dale Schinstock, 2013
/* -----------------------------------------------------------------------

The AnalogIn interface is used to read a voltage from PB0

EXAMPLE: Read voltage

#include "analog_in.h"

float voltage; // Placed here to keep in scope for debugger

int main(void)
{
  sysTickSetup(); // Sets up interrupt. Do not remove
  
  AnalogIn analog;
  
  while (1)
  {
    voltage = analog.getAvgVoltage();
  }
}
-------------------------------------------------------------------------*/

#ifndef ANALOG_INPB0_H
#define ANALOG_INPB0_H

#include "stm32f4xx.h"

class AnalogInPB0
{
  public:
    //constructors
    AnalogInPB0(void);

    //destructor
    virtual ~AnalogInPB0(void);

    //functions
    float getAvgVoltage(void);
 
  private:
    // used for testing speed
    void setupInterrupt(void);
    
    //The raw oversampled data   
    __IO uint16_t d_ADCRawValues[20];
};

#endif