//-------------------------------------------------------------------------
//  Implementation of DigitalOut
// Copyright: Dale Schinstock, 2013
//-------------------------------------------------------------------------
#include "DigitalOut.h"

// Constructor
DigitalOut::DigitalOut(myDigitalOut_TypeDef pin, 
                       GPIOOType_TypeDef Otype,
                       GPIOPuPd_TypeDef PuPd,uint8_t initValue)
{
  // Set the pin data
  switch(pin) {
    case PB11: 
      d_GPIO_PIN = GPIO_Pin_11;
      d_RCC_AHB1Periph = RCC_AHB1Periph_GPIOB;
      d_PORT = GPIOB;
      break;
    case PD10: 
      d_GPIO_PIN = GPIO_Pin_10;
      d_RCC_AHB1Periph = RCC_AHB1Periph_GPIOD;
      d_PORT = GPIOD;
      break;
    case PD0: 
      d_GPIO_PIN = GPIO_Pin_0;
      d_RCC_AHB1Periph = RCC_AHB1Periph_GPIOD;
      d_PORT = GPIOD;
      break;
    case PD1: 
      d_GPIO_PIN = GPIO_Pin_1;
      d_RCC_AHB1Periph = RCC_AHB1Periph_GPIOD;
      d_PORT = GPIOD;
      break; 
    case PD2: 
      d_GPIO_PIN = GPIO_Pin_2;
      d_RCC_AHB1Periph = RCC_AHB1Periph_GPIOD;
      d_PORT = GPIOD;
      break; 
    case PD3: 
      d_GPIO_PIN = GPIO_Pin_3;
      d_RCC_AHB1Periph = RCC_AHB1Periph_GPIOD;
      d_PORT = GPIOD;
      break;
  }
  
  // GPIOD Periph clock enable
  RCC_AHB1PeriphClockCmd(d_RCC_AHB1Periph, ENABLE);

  // Configure the GPIO_LED pin
  GPIO_InitTypeDef  GPIO_InitStructure;
  
  GPIO_InitStructure.GPIO_Pin = d_GPIO_PIN;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
  GPIO_InitStructure.GPIO_OType = Otype;  
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_PuPd = PuPd;
  
  GPIO_Init(d_PORT, &GPIO_InitStructure);

  if(initValue) {
    GPIO_SetBits(d_PORT, d_GPIO_PIN);
  }
  else {
    GPIO_ResetBits(d_PORT, d_GPIO_PIN);
  }
}

DigitalOut::~DigitalOut()
{
}

int DigitalOut::read()
{
  return GPIO_ReadOutputDataBit(d_PORT, d_GPIO_PIN);
}

void DigitalOut::write(int value)
{
  if(value) {
    GPIO_SetBits(d_PORT, d_GPIO_PIN);
  }
  else {
    GPIO_ResetBits(d_PORT, d_GPIO_PIN);
  }
}
