//-------------------------------------------------------------------------
//  Implementation of Leds
// Copyright: Dale Schinstock, 2013
//-------------------------------------------------------------------------
#include "Leds.h"

// Constructor
Leds::Leds(void)
{
  // GPIOD Periph clock enable
  RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOD, ENABLE);

  // Configure the GPIO_LED pin
  GPIO_InitTypeDef  GPIO_InitStructure;
  
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_12|GPIO_Pin_13|GPIO_Pin_14|GPIO_Pin_15;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
  
  GPIO_Init(GPIOD, &GPIO_InitStructure);

  greenState=orangeState=redState=blueState=0;
  GPIOD->BSRRH = GPIO_Pin_12|GPIO_Pin_13|GPIO_Pin_14|GPIO_Pin_15;
}

Leds::~Leds()
{
}

void Leds::set(Led_TypeDef led)
{
  switch(led)                        // reentrant and thread safe
  {
    case green:
      GPIOD->BSRRL = GPIO_Pin_12;
      break;
    case orange:
      GPIOD->BSRRL = GPIO_Pin_13;
      break;
    case red:
      GPIOD->BSRRL = GPIO_Pin_14;
      break;
    case blue:
      GPIOD->BSRRL = GPIO_Pin_15;
      break;
  }
}

void Leds::clear(Led_TypeDef led)   // reentrant and thread safe
{
  switch(led)
  {
    case green:
      GPIOD->BSRRH = GPIO_Pin_12;
      break;
    case orange:
      GPIOD->BSRRH = GPIO_Pin_13;
      break;
    case red:
      GPIOD->BSRRH = GPIO_Pin_14;
      break;
    case blue:
      GPIOD->BSRRH = GPIO_Pin_15;
      break;
  }
}

void Leds::toggle(Led_TypeDef led)    // maybe not reentrant due to  ^=
{
  switch(led)
  {
    case green:
      GPIOD->ODR ^= GPIO_Pin_12;
      break;
    case orange:
      GPIOD->ODR ^= GPIO_Pin_13;
      break;
    case red:
      GPIOD->ODR ^= GPIO_Pin_14;
      break;
    case blue:
      GPIOD->ODR ^= GPIO_Pin_15;
      break;
  }
}
