/* -----------------------------------------------------------------------
// Copyright: Dale Schinstock, 2013

The Led Interface can be used for the four on-board LEDs of the STM32F4Discovery
 green (gLED_PD12), orange (oLED_PD13), red (rLED_PD14), blue (bLED_PD15).
-------------------------------------------------------------------------*/

#ifndef LEDS_H
#define LEDS_H

#include "stm32f4xx.h"

// These are the names for the green, orange, red, and blue LEDs
// Note that the indicated pins also turn on/off
typedef enum
{
  green,       // PD12
  orange,      // PD13
  red,         // PD14
  blue         // PD15
} Led_TypeDef;

class Leds
{
  public:
    //constructors
    explicit Leds(void);

    //destructor
    virtual ~Leds();

    //functions
    void set(Led_TypeDef led);    // Turns on 
    void clear(Led_TypeDef led);  // Turns off
    void toggle(Led_TypeDef led); // Toggles

  private:

    //The pin for this LED
    uint8_t greenState, orangeState, redState, blueState;
};

#endif