// Copyright: Dale Schinstock, 2013

#include "TrigTables.h"
#include "stdint.h"
#include <math.h>

TrigTables::TrigTables(void)
{
}
      
~TrigTables::TrigTables(void)
{
}

// note output is 0 to 2*pi
float TrigTables::atan2(float y,float x)
{
 int16_t Index;
 float th;
 
  if (fabsf(y) > fabsf(x*ATANRANGE))
  {
    if (y < 0) th = -1.570796f;
    else th =  1.570796f;
  }
  else
  {
    Index = (int16_t)((y/x/ATANRANGE + 1)*TABLEN/2.0f); 
    if (Index < 0) Index=0;
    if (Index > TABLEN-1) Index=TABLEN-1;
    
    th=ATANTABLE[Index];
  
    if ((y<0)&&(x<0)) th -= 3.141593f;
    else if (x<0) th += 3.141593f;
  }
  
  if(th<0) th += 6.283185f; // change range to 0 to 2*pi 
  
  return(th);
}

// note theta range -pi to 2*pi
void TrigTables::sincos(float theta, float *sth, float *cth)
{
  int16_t CosIndex, SinIndex;

  if (theta > 3.141593f) theta -= 6.283185f;   
  
  CosIndex = (int16_t)(theta*TABLEN/2.0/3.141593f + TABLEN/2.0f); 
  if (CosIndex < 0) CosIndex=0;
  if (CosIndex > TABLEN-1) CosIndex=TABLEN-1;
  
  SinIndex=CosIndex-TABLEN/4;
  if (SinIndex < 0) SinIndex += TABLEN;
  
  *cth=COSTABLE[CosIndex];
  *sth=COSTABLE[SinIndex];
}
