function mlspeedplots(data);
% Copyright: Dale Schinstock, 2013

%Uses data generated by the motorlab software in speed control 
%example: mlvelplots(data);

%Written by DES 8/14/13

TIME=data(:,1); Command=data(:,2); Theta1=data(:,3); Theta2=data(:,4);
Speed1=data(:,5); Speed2=data(:,6); U=data(:,7); I=data(:,8); Extra=data(:,9);
Error1=Command-Speed1; Error2=Command-Speed2;

figure(1); plot(TIME,Theta1,TIME,Theta2);
title('Angular Position vs. Time');
xlabel('Time (sec)');
ylabel('Angular Position (deg)');
legend('Theta1','Theta2');

figure(2); plot(TIME,Command,TIME,Speed1,TIME,Speed2);
title('Angular Speed vs. Time');
xlabel('Time (sec)');
ylabel('Angular Speed (RPM)');
legend('Command','Speed1','Speed2');

figure(3); plot(TIME,Error1,TIME,Error2);
title('Angular Speed Error vs. Time');
xlabel('Time (sec)');
ylabel('Angular Speed Error (RPM)');
legend('Error1','Error2');

figure(4); plot(TIME,U,TIME,I);
title('Motor Current vs. Time');
xlabel('Time (sec)');
ylabel('Motor Current (Amp)');
legend('Current Command','Measured Current');

