function varargout = motorlabGUI(varargin)
% Copyright: Dale Schinstock, 2013
% MOTORLABGUI MATLAB code for motorlabGUI.fig
%      MOTORLABGUI, by itself, creates a new MOTORLABGUI or raises the existing
%      singleton*.
%
%      H = MOTORLABGUI returns the handle to a new MOTORLABGUI or the handle to
%      the existing singleton*.
%
%      MOTORLABGUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in MOTORLABGUI.M with the given input arguments.
%
%      MOTORLABGUI('Property','Value',...) creates a new MOTORLABGUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before motorlabGUI_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to motorlabGUI_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help motorlabGUI

% Last Modified by GUIDE v2.5 15-Aug-2013 08:21:18

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @motorlabGUI_OpeningFcn, ...
                   'gui_OutputFcn',  @motorlabGUI_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before motorlabGUI is made visible.
function motorlabGUI_OpeningFcn(hObject, eventdata, handles, varargin)

    [folder, name, ext] = fileparts(which('motorlabGUI'));
    addpath([folder '\supportfiles']);
    addpath([folder '\supportfiles\gloTalk']);

    handles.output = hObject; %default command line output is the fig handle
    handles = gloTalkObjInit(handles);  % Add handles of the glo Objects
    handles.gloTalk = GloTalkClass;     % Init GloTalk and add to handles
    handles.timer = timer(...
        'ExecutionMode', 'fixedRate', ...       % Run timer repeatedly
        'Period', 0.5, ...                      % set period in seconds
        'TimerFcn', {@timerCallback,hObject});  % Specify callback function

    guidata(hObject, handles);  % Update handles structure

    port = portSelectorGUI;
    if (~isempty(port))
        handles.gloTalk.serialPort.Port=port;
        fopen(handles.gloTalk.serialPort);
        refreshStatus(handles);
        success = handles.gloTalk.getObject(handles.parameters,1);
        refreshParams(handles);
        success = handles.gloTalk.getObject(handles.trapProf,1);
    end


% --- Outputs from this function are returned to the command line.
function varargout = motorlabGUI_OutputFcn(hObject, eventdata, handles) 
    varargout{1} = handles.output;


% --- Executes on button press in runWaveButton.
function runWaveButton_Callback(hObject, eventdata, handles)
    stop(handles.timer);
    if (handles.status.data.waveState==handles.status.waveStateVals.CONTINUOUS)
        cmd = handles.parameters.guiCmdVals.STOPWAVE;
    elseif (handles.status.data.waveState==handles.status.waveStateVals.STOPPED)
        cmd = handles.parameters.guiCmdVals.STARTWAVE;
    else
        if(get(handles.updateRadio,'Value')==1); start(handles.timer); end 
        return;
    end
    handles.parameters.data.guiCmd = cmd;
    success = handles.gloTalk.sendObject(handles.parameters,1);
    refreshStatus(handles);
    if(get(handles.updateRadio,'Value')==1); start(handles.timer); end 


% --- Executes on button press in runAutosaveButton.
function runAutosaveButton_Callback(hObject, eventdata, handles)
    stop(handles.timer);
    set(hObject,'Enable','off')
    if (handles.status.data.waveState==handles.status.waveStateVals.STOPPED)
        cmd = handles.parameters.guiCmdVals.STARTAUTO;
    else
        if(get(handles.updateRadio,'Value')==1); start(handles.timer); end 
        return;
    end
    handles.parameters.data.guiCmd = cmd;
    success = handles.gloTalk.sendObject(handles.parameters,1);
    refreshStatus(handles);
    while ((handles.status.data.waveState==handles.status.waveStateVals.AUTOSTART)||...
          (handles.status.data.waveState==handles.status.waveStateVals.AUTOSAVE))
        pause(0.2);
        refreshStatus(handles);
    end    
    success = handles.gloTalk.getObject(handles.logData,0);
    if success
        data = reshape([handles.logData.data(1:end).floatvals],9,2048)';
        [m,Index] = min(data(:,1));
        data(:,1) = [data(Index:end,1); data(1:(Index-1),1)]; % swap the time row
        [m,Index] = max(data(:,9));
        if (m==1)
            data(:,1) = data(:,1) - data(Index,1); % subtract the zero time of the wave
        end
        assignin('base',get(handles.saveNameEdit,'String'),data);
    end
    refreshStatus(handles);
    set(hObject,'Enable','on')
    if(get(handles.updateRadio,'Value')==1); start(handles.timer); end 

function derivGainEdit_Callback(hObject, eventdata, handles)
    stop(handles.timer);
    num = str2double(get(hObject,'String'));
    if (isnan(num))
        s = num2str(handles.parameters.data.Kd);
        set(hObject,'String',s);  % set back to correct number
        if(get(handles.updateRadio,'Value')==1); start(handles.timer); end 
        return
    end
    handles.parameters.data.guiCmd = handles.parameters.guiCmdVals.GAINS;
    handles.parameters.data.Kd = single(num);
    success = handles.gloTalk.sendObject(handles.parameters,1);
    refreshParams(handles);
    if(get(handles.updateRadio,'Value')==1); start(handles.timer); end 

% --- Executes during object creation, after setting all properties.
function derivGainEdit_CreateFcn(hObject, eventdata, handles)
    if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
        set(hObject,'BackgroundColor','white');
    end

function intGainEdit_Callback(hObject, eventdata, handles)
    stop(handles.timer);
    num = str2double(get(hObject,'String'));
    if (isnan(num))
        s = num2str(handles.parameters.data.Ki);
        set(hObject,'String',s);  % set back to correct number
        if(get(handles.updateRadio,'Value')==1); start(handles.timer); end 
        return
    end
    handles.parameters.data.guiCmd = handles.parameters.guiCmdVals.GAINS;
    handles.parameters.data.Ki = single(num);
    success = handles.gloTalk.sendObject(handles.parameters,1);
    refreshParams(handles);
    if(get(handles.updateRadio,'Value')==1); start(handles.timer); end 

% --- Executes during object creation, after setting all properties.
function intGainEdit_CreateFcn(hObject, eventdata, handles)
    if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
        set(hObject,'BackgroundColor','white');
    end

function propGainEdit_Callback(hObject, eventdata, handles)
    stop(handles.timer);
    num = str2double(get(hObject,'String'));
    if (isnan(num))
        s = num2str(handles.parameters.data.Kp);
        set(hObject,'String',s);  % set back to correct number
        if(get(handles.updateRadio,'Value')==1); start(handles.timer); end 
        return
    end
    handles.parameters.data.guiCmd = handles.parameters.guiCmdVals.GAINS;
    handles.parameters.data.Kp = single(num);
    success = handles.gloTalk.sendObject(handles.parameters,1);
    refreshParams(handles);
    if(get(handles.updateRadio,'Value')==1); start(handles.timer); end 

% --- Executes during object creation, after setting all properties.
function propGainEdit_CreateFcn(hObject, eventdata, handles)
    if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
        set(hObject,'BackgroundColor','white');
    end


% --- Executes on button press in downButton.
function downButton_Callback(hObject, eventdata, handles)
    stop(handles.timer);
    size = str2double(get(handles.jogEdit,'String'));
    command = str2double(get(handles.commandEdit,'String'));
    handles.status.data.command = single(command - size);
    success = handles.gloTalk.sendObject(handles.status,1);
    refreshStatus(handles);
    if(get(handles.updateRadio,'Value')==1); start(handles.timer); end 


% --- Executes on button press in upButton.
function upButton_Callback(hObject, eventdata, handles)
    stop(handles.timer);
    size = str2double(get(handles.jogEdit,'String'));
    command = str2double(get(handles.commandEdit,'String'));
    handles.status.data.command = single(command + size);
    success = handles.gloTalk.sendObject(handles.status,1);
    refreshStatus(handles);
    if(get(handles.updateRadio,'Value')==1); start(handles.timer); end 

function commandEdit_Callback(hObject, eventdata, handles)
    stop(handles.timer);
    num = str2double(get(hObject,'String'));
    if (isnan(num))
        s = num2str(handles.status.data.command);
        set(hObject,'String',s);  % set back to correct number
        if(get(handles.updateRadio,'Value')==1); start(handles.timer); end 
        return
    end
    handles.status.data.command = single(num);
    success = handles.gloTalk.sendObject(handles.status,1);
    refreshStatus(handles);
    if(get(handles.updateRadio,'Value')==1); start(handles.timer); end 

% --- Executes during object creation, after setting all properties.
function commandEdit_CreateFcn(hObject, eventdata, handles)
    if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
        set(hObject,'BackgroundColor','white');
    end

function waveFreqEdit_Callback(hObject, eventdata, handles)
    stop(handles.timer);
    num = str2double(get(hObject,'String'));
    if (isnan(num) || num<0)
        s = num2str(handles.parameters.data.waveFreq);
        set(hObject,'String',s);  % set back to correct number
        if(get(handles.updateRadio,'Value')==1); start(handles.timer); end 
        return
    end
    handles.parameters.data.guiCmd = handles.parameters.guiCmdVals.WFREQ;
    handles.parameters.data.waveFreq = single(num);
    success = handles.gloTalk.sendObject(handles.parameters,1);
    refreshParams(handles);
    if(get(handles.updateRadio,'Value')==1); start(handles.timer); end 

% --- Executes during object creation, after setting all properties.
function waveFreqEdit_CreateFcn(hObject, eventdata, handles)
    if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
        set(hObject,'BackgroundColor','white');
    end

function waveMagEdit_Callback(hObject, eventdata, handles)
    stop(handles.timer);
    num = str2double(get(hObject,'String'));
    if (isnan(num) || num<0)
        s = num2str(handles.parameters.data.waveMag);
        set(hObject,'String',s);  % set back to correct number
        if(get(handles.updateRadio,'Value')==1); start(handles.timer); end 
        return
    end
    handles.parameters.data.guiCmd = handles.parameters.guiCmdVals.WMAG;
    handles.parameters.data.waveMag = single(num);
    success = handles.gloTalk.sendObject(handles.parameters,1);
    refreshParams(handles);
    if(get(handles.updateRadio,'Value')==1); start(handles.timer); end 

% --- Executes during object creation, after setting all properties.
function waveMagEdit_CreateFcn(hObject, eventdata, handles)
    if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
        set(hObject,'BackgroundColor','white');
    end

% --- Executes on button press in saveDataButton.
function saveDataButton_Callback(hObject, eventdata, handles)

    stop(handles.timer)
    set(hObject,'Enable','off')
    success = handles.gloTalk.getObject(handles.logData,0);
    if success
        data = reshape([handles.logData.data(1:end).floatvals],9,2048)';
        [m,Index] = min(data(:,1));
        data(:,1) = [data(Index:end,1); data(1:(Index-1),1)]; % swap the time row
        [m,Index] = max(data(:,9));
        if (m==1)
            data(:,1) = data(:,1) - data(Index,1); % subtract the zero time of the wave
        end
        assignin('base',get(handles.saveNameEdit,'String'),data);
    end
    set(hObject,'Enable','on')
    if(get(handles.updateRadio,'Value')==1); start(handles.timer); end 


function sampleRateEdit_Callback(hObject, eventdata, handles)
    stop(handles.timer);
    num = str2double(get(hObject,'String'));
    if (isnan(num) || num<0)
        s = num2str(handles.parameters.data.sampleFreq);
        set(hObject,'String',s);  % set back to correct number
        if(get(handles.updateRadio,'Value')==1); start(handles.timer); end 
        return
    end
    handles.parameters.data.guiCmd = handles.parameters.guiCmdVals.SFREQ;
    handles.parameters.data.sampleFreq = single(num);
    success = handles.gloTalk.sendObject(handles.parameters,1);
    refreshParams(handles);
    if(get(handles.updateRadio,'Value')==1); start(handles.timer); end 

% --- Executes during object creation, after setting all properties.
function sampleRateEdit_CreateFcn(hObject, eventdata, handles)
    if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
        set(hObject,'BackgroundColor','white');
    end

function saveNameEdit_Callback(hObject, eventdata, handles)
    if ~isvarname(get(hObject,'String'))
        set(hObject,'String','NotValid')
    end

% --- Executes during object creation, after setting all properties.
function saveNameEdit_CreateFcn(hObject, eventdata, handles)
    if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
        set(hObject,'BackgroundColor','white');
    end


% --- Executes on button press in ampButton.
function ampButton_Callback(hObject, eventdata, handles)
    stop(handles.timer);
    handles.parameters.data.guiCmd = handles.parameters.guiCmdVals.AMP;
    if (handles.parameters.data.enableAmp)
        handles.parameters.data.enableAmp =uint8(0);
    else
        handles.parameters.data.enableAmp =uint8(1);
    end
    success = handles.gloTalk.sendObject(handles.parameters,1);
    refreshParams(handles);
    if(get(handles.updateRadio,'Value')==1); start(handles.timer); end 

% --- Executes on button press in resetEncodersButton.
function resetEncodersButton_Callback(hObject, eventdata, handles)
    stop(handles.timer);
    handles.parameters.data.guiCmd = handles.parameters.guiCmdVals.RESETENC;
    success = handles.gloTalk.sendObject(handles.parameters,1);
    if(get(handles.updateRadio,'Value')==1); start(handles.timer); end 

function jogEdit_Callback(hObject, eventdata, handles)
    num = str2double(get(hObject,'String'));
    if (isnan(num) || num<0)
        set(hObject,'String','1.0');  % set back to correct number
        return
    end

% --- Executes during object creation, after setting all properties.
function jogEdit_CreateFcn(hObject, eventdata, handles)
    if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
        set(hObject,'BackgroundColor','white');
    end


% --- Executes when selected object is changed in waveTypeGroup.
function waveTypeGroup_SelectionChangeFcn(hObject, eventdata, handles)
    stop(handles.timer);
    vals=handles.parameters.waveTypeVals;
    switch get(eventdata.NewValue,'Tag') % Get Tag of selected object.
        case 'sineRadio'
            type=vals.SINE;
        case 'squareRadio'
            type=vals.SQUARE;
        case 'triangleRadio'
            type=vals.TRIANGLE;
        case 'trapezoidalRadio'
            type=vals.TRAPEZOIDAL;
            trapParams = trapProfGUI([handles.trapProf.data.DX...
                                       handles.trapProf.data.Amax...
                                       handles.trapProf.data.Vmax]);
            handles.trapProf.data.DX = single(trapParams(1));
            handles.trapProf.data.Amax = single(trapParams(2));
            handles.trapProf.data.Vmax = single(trapParams(3));
            success = handles.gloTalk.sendObject(handles.trapProf,1);
            
    end
    handles.parameters.data.guiCmd = handles.parameters.guiCmdVals.WTYPE;
    handles.parameters.data.waveType = type;
    success = handles.gloTalk.sendObject(handles.parameters,1);
    refreshParams(handles);
    if(get(handles.updateRadio,'Value')==1); start(handles.timer); end 

% --- Executes when selected object is changed in controlModeGroup.
function controlModeGroup_SelectionChangeFcn(hObject, eventdata, handles)
    stop(handles.timer);
    vals=handles.parameters.controlModeVals;
    switch get(eventdata.NewValue,'Tag') % Get Tag of selected object.
        case 'openLoopRadio'
            type=vals.OPENLOOP;
        case 'positionRadio'
            type=vals.POSITION;
        case 'speedRadio'
            type=vals.SPEED;
    end
    handles.parameters.data.guiCmd = handles.parameters.guiCmdVals.CMODE;
    handles.parameters.data.controlMode = type;
    success = handles.gloTalk.sendObject(handles.parameters,1);
    refreshParams(handles);
    if(get(handles.updateRadio,'Value')==1); start(handles.timer); end 

% --- Executes when selected object is changed in feedbackSensorGroup.
function feedbackSensorGroup_SelectionChangeFcn(hObject, eventdata, handles)
    stop(handles.timer);
    vals=handles.parameters.feedbackSensorVals;
    switch get(eventdata.NewValue,'Tag') % Get Tag of selected object.
        case 'loadRadio'
            type=vals.LOAD;
        case 'motorRadio'
            type=vals.MOTOR;
    end
    handles.parameters.data.guiCmd = handles.parameters.guiCmdVals.FSENSOR;
    handles.parameters.data.feedbackSensor= type;
    success = handles.gloTalk.sendObject(handles.parameters,1);
    refreshParams(handles);
    if(get(handles.updateRadio,'Value')==1); start(handles.timer); end 

% --- Executes on button press in updateRadio.
function updateRadio_Callback(hObject, eventdata, handles)

if (get(hObject,'Value')==1)
    start(handles.timer);
else
    stop (handles.timer);
end

% --- Executes on button press in showButton.
function showButton_Callback(hObject, eventdata, handles)
    showDataColumns();

% --- Executes when user attempts to close figure1.
function figure1_CloseRequestFcn(hObject, eventdata, handles)
    stop(handles.timer);
    delete(handles.timer);
    delete(hObject);

%%%%%% START MY FUNCTIONS  %%%%%%%
%%%%%% NOT MANAGED BY GUIDE %%%%%%
function refreshParams(handles)
    p=handles.parameters;
    pdata = handles.parameters.data;
    
    str = num2str(pdata.waveMag);
    set(handles.waveMagEdit,'String',str);  
    str = num2str(pdata.waveFreq);
    set(handles.waveFreqEdit,'String',str);  
    str = num2str(pdata.Kp);
    set(handles.propGainEdit,'String',str);  
    str = num2str(pdata.Ki);
    set(handles.intGainEdit,'String',str);  
    str = num2str(pdata.Kd);
    set(handles.derivGainEdit,'String',str);  
    str = num2str(pdata.sampleFreq);
    set(handles.sampleRateEdit,'String',str);  
    str = num2str(2048/pdata.sampleFreq);
    set(handles.buffLenText,'String',str);  
    str = num2str(pdata.waveFreq*2048/pdata.sampleFreq);
    set(handles.buffCyclesText,'String',str);  
    vals = p.waveTypeVals;
    switch pdata.waveType
        case vals.SINE
            set(handles.sineRadio,'Value',1);
        case vals.SQUARE
            set(handles.squareRadio,'Value',1);
        case vals.TRIANGLE
            set(handles.triangleRadio,'Value',1);
        case vals.TRAPEZOIDAL
            set(handles.trapezoidalRadio,'Value',1);
    end
    vals = p.controlModeVals;
    switch pdata.controlMode
        case vals.OPENLOOP
            set(handles.openLoopRadio,'Value',1);
            set(handles.comText,'String','Command (Amp)');
            set(handles.magText,'String','Magnitude (Amp)');
            set(handles.trapezoidalRadio,'Enable','off');
        case vals.POSITION
            set(handles.positionRadio,'Value',1);
            set(handles.comText,'String','Command (deg)');
            set(handles.magText,'String','Magnitude (deg)');
            set(handles.trapezoidalRadio,'Enable','on');
        case vals.SPEED
            set(handles.speedRadio,'Value',1);
            set(handles.comText,'String','Command (RPM)');
            set(handles.magText,'String','Magnitude (RPM)');            set(handles.trapezoidalRadio,'Enable','off');
            set(handles.trapezoidalRadio,'Enable','off');
    end
    vals = p.feedbackSensorVals;
    switch pdata.feedbackSensor
        case vals.LOAD
            set(handles.loadRadio,'Value',1);
        case vals.MOTOR
            set(handles.motorRadio,'Value',1);
    end

    if (pdata.enableAmp)
        set(handles.ampButton,'BackgroundColor','green');
        set(handles.ampButton,'String','Turn Off Motor Amp');
    else
        set(handles.ampButton,'BackgroundColor',[0.941176470588235,0.941176470588235,0.941176470588235]);
        set(handles.ampButton,'String','Turn On Motor Amp');
    end
    if (pdata.waveType == p.waveTypeVals.TRAPEZOIDAL)
        set(handles.waveFreqEdit,'Enable','off');
    else
        set(handles.waveFreqEdit,'Enable','on');
    end

%--------------------------------------------------------------------    
 function refreshStatus(handles)
    success = handles.gloTalk.getObject(handles.status,1);
    s=handles.status;
    sdata = handles.status.data;
    
    str = num2str(sdata.motPos);
    set(handles.motorPosText,'String',str);  
    str = num2str(sdata.motSpeed);
    set(handles.motorVelText,'String',str);  
    str = num2str(sdata.loadPos);
    set(handles.loadPosText,'String',str);  
    str = num2str(sdata.loadSpeed);
    set(handles.loadVelText,'String',str);  
    str = num2str(sdata.command);
    set(handles.commandEdit,'String',str);  
    if (sdata.waveState == s.waveStateVals.CONTINUOUS);
        continuous=1; autosave=0;
    elseif (sdata.waveState == s.waveStateVals.STOPPED)
        continuous=0; autosave=0;
    else
        continuous=0; autosave=1;
    end
    set(handles.runWaveButton,'Enable','on');
    set(handles.runAutosaveButton,'Enable','on');
    if (continuous)
        set(handles.runWaveButton,'BackgroundColor','green');
        set(handles.runWaveButton,'String','Stop Wave Continuous');
        set(handles.runAutosaveButton,'Enable','off');
    else
        set(handles.runWaveButton,'BackgroundColor',[0.941176470588235,0.941176470588235,0.941176470588235]);
        set(handles.runWaveButton,'String','Run Wave Continuous');
    end
    if (autosave)
        set(handles.runAutosaveButton,'BackgroundColor','green');
        set(handles.runAutosaveButton,'String','Running AutoSave');
        set(handles.runAutosaveButton,'Enable','off');
        set(handles.runWaveButton,'Enable','off');
    else
        set(handles.runAutosaveButton,'BackgroundColor',[0.941176470588235,0.941176470588235,0.941176470588235]);
        set(handles.runAutosaveButton,'String','Run Wave AutoSave');
    end
     
%--------------------------------------------------------------------    
function timerCallback(hObject,eventdata,hfigure)
    
    handles = guidata(hfigure);
    %stop(handles.timer);  % use for debugging
    refreshStatus(handles);
    

%%%%%%% END MY FUNCTIONS
