function handles = gloTalkObjInit(handles)
% Copyright: Dale Schinstock, 2013

% TO DEFINE A NEW OBJECT:
% 1) provide an appropriate gloTalkObject file
% 2) add two lines below:
%    a) first arg of the constructor is the unique ID (1-254), matching
%       id in the micro.
%    b) second arg of the constructor is the number (1-65536) of objects
%       of this type, matching the micro also.  

  [folder, name, ext] = fileparts(which('gloTalkObjInit'));
  addpath([folder '\gloTalkObjects']);

  handles.trapProf = TrapProf(1,1);
  handles.gloHandles{1} = handles.trapProf;
  handles.logData = LogData(2,2048);
  handles.gloHandles{2} = handles.logData;
  handles.parameters = Parameters(3,1);
  handles.gloHandles{3} = handles.parameters;
  handles.status = Status(4,1);
  handles.gloHandles{4} = handles.status;
end

