// Copyright: Dale Schinstock, 2013

#include "GloObjectTemplate.h"
#include <string.h>

// Constructor
template <typename objectDataType> GloObjectTemplate<objectDataType>::GloObjectTemplate(uint8_t id, uint16_t numInstance)
{
  md.id = id;
  md.numBytes = sizeof(objectDataType);
  md.numInstance = numInstance;
  md.dataPtr = (void *)&(data);
}

// Destructor
template <typename objectDataType> GloObjectTemplate<objectDataType>::~GloObjectTemplate()
{
}

template <typename objectDataType> void  GloObjectTemplate<objectDataType>::getDataCopy(uint16_t instance, objectDataType *copy)
{
//  __disable_irq();  // disable all interrupts
  memcpy( (void *)copy, (void const *)&(data[instance-1]), md.numBytes);
//  __enable_irq(); //  enable interrupts
}

template <typename objectDataType> void GloObjectTemplate<objectDataType>::setData(objectDataType dataStruct, uint16_t instance)
{
  uint32_t instancePtr;   
  instancePtr = (uint32_t)md.dataPtr + (uint32_t)(instance-1)*md.numBytes;
  
//  __disable_irq();  // disable all interrupts
  memcpy( (void *)instancePtr, (void const *)&(dataStruct), md.numBytes);
//  __enable_irq(); //  enable interrupts
}