// Copyright: Dale Schinstock, 2013

#include "GloOS.h"
#include "telemSendThread.h"
#include <string.h>
#include "GloLink.h"
#include <stdint.h>

void telemSendThread(void)
{
  uint8_t objID;
  uint16_t instance, numInstance, start;  
  
  while (gloOS.telemQueue.take(&objID,&instance))
  {  
    if (instance>0)
    {
      if(!gloLink.sendObject(objID,instance))
        return;                                //return on timeout
    }
    else    // instance = 0 means send all instances
    {
      numInstance = gloObjectPtrs[objID]->md.numInstance;
      //logData treated specially
      if (objID == logData.md.id) // for this wait for mutex and unwrap data 
      {
        while (!gloOS.mutexLock(GLOOSDATAMUTEX));  //wait till not being written
        if (status.data.waveState == AUTOPAUSE)
          status.data.waveState = STOPPED;
        start = status.data.logDataPtr + 1;
        if (start >= numInstance) start = 0;
        for (uint16_t i=start; i < numInstance; i++)
        {
          if(!gloLink.sendObject(objID,i+1))
            return;                             //return on timeout
        }
        for (uint16_t i=0; i < start; i++)
        {
          if(!gloLink.sendObject(objID,i+1))
            return;                             //return on timeout
        }
        gloOS.mutexUnlock(GLOOSDATAMUTEX);      //allow data to be written 
      }
      // other objects if all instances requested
      else
        for (uint16_t i=0; i < numInstance ; i++)
        {
          if(!gloLink.sendObject(objID,i+1))
            return;                             //return on timeout
        }
    }
  }
}

